# Generated by Django 3.0.4 on 2020-03-23 12:34

import django.contrib.gis.db.models.fields
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="EPCI",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "code",
                    models.CharField(
                        editable=False, max_length=10, unique=True, verbose_name="Code"
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("CA", "Communauté d'agglomération"),
                            ("CC", "Communauté de communes"),
                            ("CU", "Communauté urbaine"),
                            ("ME", "Métropole"),
                        ],
                        max_length=2,
                        verbose_name="Type d'EPCI",
                    ),
                ),
                ("nom", models.CharField(max_length=300, verbose_name="Nom de l'EPCI")),
            ],
        ),
        migrations.CreateModel(
            name="Commune",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "code",
                    models.CharField(
                        editable=False, max_length=10, verbose_name="Code de la commune"
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("COM", "Commune"),
                            ("COMD", "Commune déléguée"),
                            ("COMA", "Commune associée"),
                            ("ARM", "Arrondissement de Paris/Lyon/Marseille"),
                            ("SEC", "Secteur électoral de Paris/Lyon/Marseille"),
                        ],
                        default="COM",
                        editable=False,
                        max_length=4,
                        verbose_name="Type de commune",
                    ),
                ),
                (
                    "nom",
                    models.CharField(
                        editable=False, max_length=200, verbose_name="Nom de la commune"
                    ),
                ),
                (
                    "type_nom",
                    models.PositiveSmallIntegerField(
                        editable=False, verbose_name="Type de nom de la commune"
                    ),
                ),
                (
                    "code_departement",
                    models.CharField(max_length=5, verbose_name="Code du département"),
                ),
                (
                    "population_municipale",
                    models.PositiveIntegerField(
                        verbose_name="Population municipale", null=True
                    ),
                ),
                (
                    "population_cap",
                    models.PositiveIntegerField(
                        verbose_name="Population comptée à part", null=True
                    ),
                ),
                (
                    "commune_parent",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="composants",
                        related_query_name="composant",
                        to="data_france.Commune",
                    ),
                ),
                (
                    "epci",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="communes",
                        related_query_name="commune",
                        to="data_france.EPCI",
                    ),
                ),
            ],
            options={"verbose_name": "Commune", "verbose_name_plural": "Communes",},
        ),
        migrations.AddField(
            model_name="commune",
            name="geometry",
            field=django.contrib.gis.db.models.fields.MultiPolygonField(
                geography=True, null=True, srid=4326, verbose_name="Géométrie"
            ),
        ),
        migrations.AddConstraint(
            model_name="commune",
            constraint=models.CheckConstraint(
                check=models.Q(
                    models.Q(("commune_parent__isnull", True), ("type", "COM")),
                    models.Q(
                        ("commune_parent__isnull", False),
                        models.Q(_negated=True, type="COM"),
                    ),
                    _connector="OR",
                ),
                name="commune_deleguees_associees_constraint",
            ),
        ),
        migrations.AddConstraint(
            model_name="commune",
            constraint=models.UniqueConstraint(
                condition=models.Q(type="COM"),
                fields=("code",),
                name="commune_unique_code",
            ),
        ),
    ]
